class PromizeTab extends React.Component {

    componentWillMount() {
        const { pzCustomizer } = this.props;
        const tabs = this.props.pzCustomizer.tabs ? this.props.pzCustomizer.tabs : {}
        Object.keys(tabs).length > 0 && Object.keys(tabs).map((tab, index) => {
            fetch(this.props.pzApiUrl + 'getSubTabsWithTabId/?id=' + tab)
                .then(res => res.json())
                .then(response => {
                    response.subtabs.length > 0 && response.subtabs.map((sub_tab, tab_idex) => {
                        if (!pzCustomizer.subtabs[tab]) {
                            pzCustomizer.subtabs[tab] = {}
                        }
                        pzCustomizer.subtabs[tab][sub_tab.child_tab_id] = sub_tab
                    })
                    this.props.HomeComponent.setState({ pzCustomizer });
                })
        })
    }

    onChangeHandler = (e, PZTab) =>{
        let {pzActiveOptions} = this.props
        const { pzCanvas, pzCanvasObject, pzCrossOrigin, pzCurrentView } = this.props;

        pzActiveOptions[PZTab.promize_tab_id] = e.target.value
        PZTab.value = e.target.value
        let pzObject = pzCreateCanvasObject(pzCurrentView, 'tab', PZTab, pzCanvas, pzCurrentView, pzCrossOrigin, this.props.HomeComponent)
        pzCanvasObject[pzCurrentView][pzObject.name] = pzObject;
        this.props.HomeComponent.setState({ pzActiveOptions, pzCanvasObject });
    }

    onClickRemoveOptions = (PZTab) => {
        let {pzActiveOptions} = this.props
        const { pzCanvas, pzCanvasObject, pzCrossOrigin, pzCurrentView } = this.props;
        // console.log("pzCanvasObject", pzCanvasObject);
        console.log("pzActiveOptions", pzActiveOptions);
        const fobject = pzCanvasObject[pzCurrentView];   
        console.log("fobject", fobject);    
        const layer_array1 = Object.values(fobject).filter(function (propertyName) {
            return propertyName.layerno == 2
        });
        console.log("layer_array1", layer_array1);
        const layer_array2 = Object.values(fobject).filter(function (propertyName) {
            return propertyName.layerno == 3
        });
        console.log("layer_array2", layer_array2);
        const finalLayerArray = [...layer_array1, ...layer_array2]
        console.log("finalLayerArray", finalLayerArray);
        const propertyNames = finalLayerArray.map(value => value.name)
        console.log("propertyNames", propertyNames);
        // const propertyNames = Object.values(fobject).filter(function (propertyName) {
        //     console.log("propertyName", propertyName);
        //     // return propertyName.indexOf("FObject_option") === 0;
        //     return propertyName.layerno == 2 && propertyName.layerno == 3;
        // });
        // console.log("propertyNames", propertyNames);
        // const activeOptionsarray = propertyNames.map(value => value.split('FObject_option_').join(''))
        const activeOptionsarray = finalLayerArray.map(value => value.name.split('FObject_option_').join(''))
        console.log("activeOptionsarray", activeOptionsarray);
        propertyNames.forEach(function(name) {
            delete pzCanvasObject[pzCurrentView][name];
            let canvasObj = pzCanvas.getItemByName(name);
            pzRemoveObjectFromCanvas(pzCanvas, canvasObj)
        });
        activeOptionsarray.forEach(function(option) {
            delete pzActiveOptions[option]
        })
        console.log("pzCanvasObject after deleting", pzCanvasObject);
        console.log("pzActiveOptions after deleting", pzActiveOptions);
        this.props.HomeComponent.setState({ pzActiveOptions, pzCanvasObject });
    }

    render() {
        const tabs = this.props.pzCustomizer.tabs ? this.props.pzCustomizer.tabs : {}
        return (
            <React.Fragment>
                {(Object.keys(tabs).length > 0) && <PZTab pzTabs={tabs} onClickRemoveOptions={this.onClickRemoveOptions} onChangeHandler={this.onChangeHandler} {...this.props} />}
            </React.Fragment>
        );
    }
}
